
/***************************************************************************

    Disk Based Hash library DBH

copyright Edscott Wilson Garcia 2002-2010 edscott@xfce.org
published under LGPL Public license
You should have received a license copy along with this file.

*************************************************************************


- bigendian machines should have -DTURN for binary file compatibility.
  if this is not needed, increased speed comes from *not* using -DTURN

For compilers:

DBH version 1.0 had 32 bit filepointers. This is incompatible with
DBH version 2.0 which has 64 bit filepointers.

Type FILEPOINTER determined by configure script to 64 bits.
DBH version 2 requires size_t to be at least 64 bits to compile.

If sizeof(size_t) is less than 64 bits, DBH version 2.0 will not compile
****************************************************************************/
#define COPYRIGHT "DBH copyright 2000-2010 LGPL, Edscott Wilson Garcia. See http://dbh.sourceforge.net/ for source code"

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <pthread.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/stat.h>


#ifdef HAVE_MACHINE_LIMITS_H
#include <machine/limits.h>
#else
#include <limits.h>
#endif

#include "config.h"
#include "dbh.h"
#include "dbh_private.h"
#include "dbh_functions2.h"


#ifndef DBH_VERSION
#error "DBH_VERSION NOT DEFINED"
#endif

/*   with 19 keys out of the 256 key length maximum
     we have the full 256^8 records! thus
     no need to grow further. And this is using a decimal
     based key.
     for article, need comparisons with other databases or ways to
     solve the big dataset access problem... 
    */

#define NEW 1
#define OLD 0

#define DEFAULT_DBH_DATASIZE 1024


#define READ                    0
#define WRITE                   1
#define DOWN                    0
#define UP                      1

#define WRITEBRANCHES           1
#define DONTWRITEBRANCHES       0

#define PRESENTE  				  0
#define PRESENTE_MENOR_BOF      0
#define PRESENTE_MENOR          1
#define PRESENTE_MAYORIGUAL     2
#define ARCHIVO_VACIO           3
#define NO_PRESENTE             4
#define ERROR_VALUE             0

#define ERASED (dbh->flag&0x01)
#define TOGGLE_ERASE (dbh->flag ^= 0x01)
#define SET_UNERASED (dbh->flag &= (0xff ^ 0x01))
#define SET_ERASED (dbh->flag |= 0x01)
#define EZIP_NUMERO_MAXIMO 16777215
//#define DBG printf
#define DBG(...)  
#define TRACE(...)
/* static: */
#include "dbh_static.c"

/* global:  */
#include "dbh_exported.c"
